## ultimatepp-ultimatepp.zip

=== Makefile ===
UPPDIR1 = ./uppsrc/
UPPDIR2 = /home/cxl/.config/u++/umk/UppHub/gdal/
UPPDIR3 = /home/cxl/.config/u++/umk/UppHub/eigen/

UPPOUT = .cache/upp.out/
CINC   =  -I$(UPPDIR1) -I$(UPPDIR2) -I$(UPPDIR3) `pkg-config --cflags libpng` `pkg-config --cflags freetype2` `pkg-config --cflags fontconfig` `pkg-config --cflags x11` `pkg-config --cflags xcb` `pkg-config --cflags expat` `pkg-config --cflags xinerama` `pkg-config --cflags xrender` `pkg-config --cflags xft` `pkg-config --cflags xdmcp` `pkg-config --cflags xext` `pkg-config --cflags gtk+-3.0` `pkg-config --cflags libnotify` -I./ -I$(UPPOUT)
Macro  =  -DflagGUI -DflagGCC -DflagSHARED -DflagPOSIX -DflagLINUX
CXX = c++
LINKER = $(CXX)
CFLAGS = -O3 -ffunction-sections -fdata-sections 
CXXFLAGS = -O3 -ffunction-sections -fdata-sections  -std=c++17
LDFLAGS = -Wl,--gc-sections $(LINKOPTIONS)
LIBPATH =
AR = ar -sr

OutDir_ide = $(UPPOUT)ide/GCC-Gcc-Gui-Linux-Main-Posix-Shared/
Macro_ide = $(Macro) -DflagMAIN
OutDir_ide_Common = $(UPPOUT)ide/Common/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Common = $(Macro)
OutDir_ide_Core = $(UPPOUT)ide/Core/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Core = $(Macro)
OutDir_ide_LayDes = $(UPPOUT)ide/LayDes/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_LayDes = $(Macro)
OutDir_ide_Builders = $(UPPOUT)ide/Builders/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Builders = $(Macro)
OutDir_ide_Debuggers = $(UPPOUT)ide/Debuggers/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Debuggers = $(Macro)
OutDir_ide_Browser = $(UPPOUT)ide/Browser/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Browser = $(Macro)
OutDir_CodeEditor = $(UPPOUT)CodeEditor/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_CodeEditor = $(Macro)
OutDir_CtrlLib = $(UPPOUT)CtrlLib/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_CtrlLib = $(Macro)
OutDir_plugin_bz2 = $(UPPOUT)plugin/bz2/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_bz2 = $(Macro)
OutDir_HexView = $(UPPOUT)HexView/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_HexView = $(Macro)
OutDir_TextDiffCtrl = $(UPPOUT)TextDiffCtrl/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_TextDiffCtrl = $(Macro)
OutDir_TabBar = $(UPPOUT)TabBar/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_TabBar = $(Macro)
OutDir_ide_Designers = $(UPPOUT)ide/Designers/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Designers = $(Macro)
OutDir_ide_Android = $(UPPOUT)ide/Android/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Android = $(Macro)
OutDir_ide_Java = $(UPPOUT)ide/Java/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Java = $(Macro)
OutDir_ide_MacroManager = $(UPPOUT)ide/MacroManager/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_MacroManager = $(Macro)
OutDir_Report = $(UPPOUT)Report/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Report = $(Macro)
OutDir_Core_SSL = $(UPPOUT)Core/SSL/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Core_SSL = $(Macro)
OutDir_plugin_md = $(UPPOUT)plugin/md/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_md = $(Macro)
OutDir_ide_clang = $(UPPOUT)ide/clang/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_clang = $(Macro)
OutDir_Esc = $(UPPOUT)Esc/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Esc = $(Macro)
OutDir_Core = $(UPPOUT)Core/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Core = $(Macro)
OutDir_plugin_lzma = $(UPPOUT)plugin/lzma/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_lzma = $(Macro)
OutDir_plugin_lz4 = $(UPPOUT)plugin/lz4/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_lz4 = $(Macro)
OutDir_plugin_zstd = $(UPPOUT)plugin/zstd/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_zstd = $(Macro)
OutDir_RichEdit = $(UPPOUT)RichEdit/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_RichEdit = $(Macro)
OutDir_plugin_png = $(UPPOUT)plugin/png/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_png = $(Macro)
OutDir_Draw = $(UPPOUT)Draw/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Draw = $(Macro)
OutDir_PdfDraw = $(UPPOUT)PdfDraw/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_PdfDraw = $(Macro)
OutDir_Painter = $(UPPOUT)Painter/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Painter = $(Macro)
OutDir_plugin_pcre = $(UPPOUT)plugin/pcre/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_pcre = $(Macro)
OutDir_CtrlCore = $(UPPOUT)CtrlCore/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_CtrlCore = $(Macro)
OutDir_plugin_bmp = $(UPPOUT)plugin/bmp/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_bmp = $(Macro)
OutDir_RichText = $(UPPOUT)RichText/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_RichText = $(Macro)
OutDir_ide_IconDes = $(UPPOUT)ide/IconDes/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_IconDes = $(Macro)
OutDir_plugin_gif = $(UPPOUT)plugin/gif/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_gif = $(Macro)
OutDir_plugin_jpg = $(UPPOUT)plugin/jpg/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_jpg = $(Macro)

OutDir = $(OutDir_ide)
OutFile = ./ide

.PHONY: all
all: prepare $(OutFile)

.PHONY: build_info
build_info:
	(date '+#define bmYEAR    %y%n#define bmMONTH   %m%n#define bmDAY     %d%n#define bmHOUR    %H%n#define bmMINUTE  %M%n#define bmSECOND  %S%n#define bmTIME    Time( %y, %m, %d, %H, %M, %S )' | sed 's| 0\([[:digit:]]\)| \1|g' && \
	echo '#define bmMACHINE "'`hostname`'"' && \
	echo '#define bmUSER    "'`whoami`'"') > "$(UPPOUT)/build_info.h"

.PHONY: prepare
prepare: \
	$(OutDir_ide) \
	$(OutDir_ide_Common) \
	$(OutDir_ide_Core) \
	$(OutDir_ide_LayDes) \
	$(OutDir_ide_Builders) \
	$(OutDir_ide_Debuggers) \
	$(OutDir_ide_Browser) \
	$(OutDir_CodeEditor) \
	$(OutDir_CtrlLib) \
	$(OutDir_plugin_bz2) \
	$(OutDir_HexView) \
	$(OutDir_TextDiffCtrl) \
	$(OutDir_TabBar) \
	$(OutDir_ide_Designers) \
	$(OutDir_ide_Android) \
	$(OutDir_ide_Java) \
	$(OutDir_ide_MacroManager) \
	$(OutDir_Report) \
	$(OutDir_Core_SSL) \
	$(OutDir_plugin_md) \
	$(OutDir_ide_clang) \
	$(OutDir_Esc) \
	$(OutDir_Core) \
	$(OutDir_plugin_lzma) \
	$(OutDir_plugin_lz4) \
	$(OutDir_plugin_zstd) \
	$(OutDir_RichEdit) \
	$(OutDir_plugin_png) \
	$(OutDir_Draw) \
	$(OutDir_PdfDraw) \
	$(OutDir_Painter) \
	$(OutDir_plugin_pcre) \
	$(OutDir_CtrlCore) \
	$(OutDir_plugin_bmp) \
	$(OutDir_RichText) \
	$(OutDir_ide_IconDes) \
	$(OutDir_plugin_gif) \
	$(OutDir_plugin_jpg)

$(OutFile): build_info  \
	$(OutDir_ide)BaseDlg.o \
	$(OutDir_ide)SelectPkg.o \
	$(OutDir_ide)UppWspc.o \
	$(OutDir_ide)NewPackageFile.o \
	$(OutDir_ide)Organizer.o \
	$(OutDir_ide)Template.o \
	$(OutDir_ide)Console.o \
	$(OutDir_ide)FindFile.o \
	$(OutDir_ide)FindInFiles.o \
	$(OutDir_ide)Config.o \
	$(OutDir_ide)ide.o \
	$(OutDir_ide)idefile.o \
	$(OutDir_ide)EditorTabBar.o \
	$(OutDir_ide)Bottom.o \
	$(OutDir_ide)t.o \
	$(OutDir_ide)AssistDisplay.o \
	$(OutDir_ide)IncludeTrick.o \
	$(OutDir_ide)Assist.o \
	$(OutDir_ide)DCopy.o \
	$(OutDir_ide)ContextGoto.o \
	$(OutDir_ide)GoToLine.o \
	$(OutDir_ide)Swaps.o \
	$(OutDir_ide)Usage.o \
	$(OutDir_ide)ParamInfo.o \
	$(OutDir_ide)Navigator.o \
	$(OutDir_ide)Annotations.o \
	$(OutDir_ide)Virtuals.o \
	$(OutDir_ide)Events.o \
	$(OutDir_ide)NavDlg.o \
	$(OutDir_ide)Log.o \
	$(OutDir_ide)MainConfig.o \
	$(OutDir_ide)Setup.o \
	$(OutDir_ide)Custom.o \
	$(OutDir_ide)Print.o \
	$(OutDir_ide)InsertImage.o \
	$(OutDir_ide)Insert.o \
	$(OutDir_ide)idetool.o \
	$(OutDir_ide)Install.o \
	$(OutDir_ide)Android.o \
	$(OutDir_ide)idebar.o \
	$(OutDir_ide)background.o \
	$(OutDir_ide)idewin.o \
	$(OutDir_ide)main.o \
	$(OutDir_ide)CommandLineHandler.o \
	$(OutDir_ide)About.o \
	$(OutDir_ide)Macro.o \
	$(OutDir_ide)Help.o \
	$(OutDir_ide)SlideShow.o \
	$(OutDir_ide)OnlineSearch.o \
	$(OutDir_ide)Errors.o \
	$(OutDir_ide)Calc.o \
	$(OutDir_ide)FormatCode.o \
	$(OutDir_ide)Abbr.o \
	$(OutDir_ide)Qtf.o \
	$(OutDir_ide)Xml.o \
	$(OutDir_ide)Json.o \
	$(OutDir_ide)MacroManager.o \
	$(OutDir_ide)SetupGIT.o \
	$(OutDir_ide)Upgrade.o \
	$(OutDir_ide)UppHub.o \
	$(OutDir_ide)MethodsCtrls.o \
	$(OutDir_ide)Methods.o \
	$(OutDir_ide)AutoSetup.o \
	$(OutDir_ide)InstantSetup.o \
	$(OutDir_ide)OutputMode.o \
	$(OutDir_ide)Build.o \
	$(OutDir_ide)Debug.o \
	$(OutDir_ide)Valgrind.o \
	$(OutDir_ide)Export.o \
	$(OutDir_ide)RepoConsole.o \
	$(OutDir_ide)RepoSync.o \
	$(OutDir_ide)Credentials.o \
	$(OutDir_ide)Diff.o \
	$(OutDir_ide)DirRepoDiff.o \
	$(OutDir_ide_Common)Common.a \
	$(OutDir_ide_Core)Core.a \
	$(OutDir_ide_LayDes)LayDes.a \
	$(OutDir_ide_Builders)Builders.a \
	$(OutDir_ide_Debuggers)Debuggers.a \
	$(OutDir_ide_Browser)Browser.a \
	$(OutDir_CodeEditor)CodeEditor.a \
	$(OutDir_CtrlLib)CtrlLib.a \
	$(OutDir_plugin_bz2)bz2.a \
	$(OutDir_HexView)HexView.a \
	$(OutDir_TextDiffCtrl)TextDiffCtrl.a \
	$(OutDir_TabBar)TabBar.a \
	$(OutDir_ide_Designers)Designers.a \
	$(OutDir_ide_Android)Android.a \
	$(OutDir_ide_Java)Java.a \
	$(OutDir_ide_MacroManager)MacroManager.a \
	$(OutDir_Report)Report.a \
	$(OutDir_Core_SSL)SSL.o \
	$(OutDir_Core_SSL)SSL.a \
	$(OutDir_plugin_md)md.a \
	$(OutDir_ide_clang)clang.a \
	$(OutDir_Esc)Esc.a \
	$(OutDir_Core)Core.a \
	$(OutDir_plugin_lzma)lzma.a \
	$(OutDir_plugin_lz4)lz4.a \
	$(OutDir_plugin_zstd)zstd.a \
	$(OutDir_RichEdit)RichEdit.a \
	$(OutDir_plugin_png)pngreg.o \
	$(OutDir_plugin_png)png.a \
	$(OutDir_Draw)Draw.a \
	$(OutDir_PdfDraw)PdfInit.o \
	$(OutDir_PdfDraw)PdfDraw.a \
	$(OutDir_Painter)PainterInit.o \
	$(OutDir_Painter)Painter.a \
	$(OutDir_plugin_pcre)pcre.a \
	$(OutDir_CtrlCore)CtrlCore.a \
	$(OutDir_plugin_bmp)BmpReg.o \
	$(OutDir_plugin_bmp)bmp.a \
	$(OutDir_RichText)RichText.a \
	$(OutDir_ide_IconDes)IconDes.a \
	$(OutDir_plugin_gif)gif.o \
	$(OutDir_plugin_gif)gif.a \
	$(OutDir_plugin_jpg)jpgreg.o \
	$(OutDir_plugin_jpg)jpg.a
	$(LINKER) -o "$(OutFile)" -Wl,-s $(LIBPATH) -Wl,-O,2 $(LDFLAGS) -Wl,--start-group  \
		$(OutDir_ide)BaseDlg.o \
		$(OutDir_ide)SelectPkg.o \
		$(OutDir_ide)UppWspc.o \
		$(OutDir_ide)NewPackageFile.o \
		$(OutDir_ide)Organizer.o \
		$(OutDir_ide)Template.o \
		$(OutDir_ide)Console.o \
		$(OutDir_ide)FindFile.o \
		$(OutDir_ide)FindInFiles.o \
		$(OutDir_ide)Config.o \
		$(OutDir_ide)ide.o \
		$(OutDir_ide)idefile.o \
		$(OutDir_ide)EditorTabBar.o \
		$(OutDir_ide)Bottom.o \
		$(OutDir_ide)t.o \
		$(OutDir_ide)AssistDisplay.o \
		$(OutDir_ide)IncludeTrick.o \
		$(OutDir_ide)Assist.o \
		$(OutDir_ide)DCopy.o \
		$(OutDir_ide)ContextGoto.o \
		$(OutDir_ide)GoToLine.o \
		$(OutDir_ide)Swaps.o \
		$(OutDir_ide)Usage.o \
		$(OutDir_ide)ParamInfo.o \
		$(OutDir_ide)Navigator.o \
		$(OutDir_ide)Annotations.o \
		$(OutDir_ide)Virtuals.o \
		$(OutDir_ide)Events.o \
		$(OutDir_ide)NavDlg.o \
		$(OutDir_ide)Log.o \
		$(OutDir_ide)MainConfig.o \
		$(OutDir_ide)Setup.o \
		$(OutDir_ide)Custom.o \
		$(OutDir_ide)Print.o \
		$(OutDir_ide)InsertImage.o \
		$(OutDir_ide)Insert.o \
		$(OutDir_ide)idetool.o \
		$(OutDir_ide)Install.o \
		$(OutDir_ide)Android.o \
		$(OutDir_ide)idebar.o \
		$(OutDir_ide)background.o \
		$(OutDir_ide)idewin.o \
		$(OutDir_ide)main.o \
		$(OutDir_ide)CommandLineHandler.o \
		$(OutDir_ide)About.o \
		$(OutDir_ide)Macro.o \
		$(OutDir_ide)Help.o \
		$(OutDir_ide)SlideShow.o \
		$(OutDir_ide)OnlineSearch.o \
		$(OutDir_ide)Errors.o \
		$(OutDir_ide)Calc.o \
		$(OutDir_ide)FormatCode.o \
		$(OutDir_ide)Abbr.o \
		$(OutDir_ide)Qtf.o \
		$(OutDir_ide)Xml.o \
		$(OutDir_ide)Json.o \
		$(OutDir_ide)MacroManager.o \
		$(OutDir_ide)SetupGIT.o \
		$(OutDir_ide)Upgrade.o \
		$(OutDir_ide)UppHub.o \
		$(OutDir_ide)MethodsCtrls.o \
		$(OutDir_ide)Methods.o \
		$(OutDir_ide)AutoSetup.o \
		$(OutDir_ide)InstantSetup.o \
		$(OutDir_ide)OutputMode.o \
		$(OutDir_ide)Build.o \
		$(OutDir_ide)Debug.o \
		$(OutDir_ide)Valgrind.o \
		$(OutDir_ide)Export.o \
		$(OutDir_ide)RepoConsole.o \
		$(OutDir_ide)RepoSync.o \
		$(OutDir_ide)Credentials.o \
		$(OutDir_ide)Diff.o \
		$(OutDir_ide)DirRepoDiff.o \
			$(OutDir_ide_Common)Common.a \
			$(OutDir_ide_Core)Core.a \
			$(OutDir_ide_LayDes)LayDes.a \
			$(OutDir_ide_Builders)Builders.a \
			$(OutDir_ide_Debuggers)Debuggers.a \
			$(OutDir_ide_Browser)Browser.a \
			$(OutDir_CodeEditor)CodeEditor.a \
			$(OutDir_CtrlLib)CtrlLib.a \
			$(OutDir_plugin_bz2)bz2.a \
			$(OutDir_HexView)HexView.a \
			$(OutDir_TextDiffCtrl)TextDiffCtrl.a \
			$(OutDir_TabBar)TabBar.a \
			$(OutDir_ide_Designers)Designers.a \
			$(OutDir_ide_Android)Android.a \
			$(OutDir_ide_Java)Java.a \
			$(OutDir_ide_MacroManager)MacroManager.a \
			$(OutDir_Report)Report.a \
