=== uppbox/lpbuild/Makefile ===
########################################################################
#     __  __  __   ____  __  __  __   __  ____  ___     _      _       #
#    (  )(  )(  ) (_  _)(  )(  \/  ) (  )(_  _)(  _)  _( )_  _( )_     #
#     )(__)(  )(__  )(   )(  )    (  /__\  )(   ) _) (_   _)(_   _)    #
#     \____/ (____)(__) (__)(_/\/\_)(_)(_)(__) (___)   (_)    (_)      #
#        ___  ___    __   __  __  ___  _    _  __   ___   _  _         #
#       (  _)(  ,)  (  ) (  \/  )(  _)( \/\/ )/  \ (  ,) ( )/ )        #
#        ) _) )  \  /__\  )    (  ) _) \    /( () ) )  \  )  \         #
#       (_)  (_)\_)(_)(_)(_/\/\_)(___)  \/\/  \__/ (_)\_)(_)\_)        #
#              __  __   __   _  _  ___  ___  __  __    ___             #
#             (  \/  ) (  ) ( )/ )(  _)(  _)(  )(  )  (  _)            #
#              )    (  /__\  )  \  ) _) ) _) )(  )(__  ) _)            #
#             (_/\/\_)(_)(_)(_)\_)(___)(_)  (__)(____)(___)            #
#                                                                      #
########################################################################

############################## USAGE ###################################
# This makefile is controlled through a set of variables, similar to   #
# any other makefile. The prefered way to change them is via command   #
# line, e.g.: make "PKG=ide usvn" CC=g++                               #
#                                                                      #
# All of the variables that can control the bahaviour are listed below #
# in DEFAULTS section. Also their default value is shown here.         #
#                                                                      #
# For boolean type of variables, values of y, Y, yes, YES, Yes, true,  #
# True, TRUE, T, t, 1, on, On, ON and @ are considered true. Anything  #
# else is evaluated as false.                                          #
############################# TARGETS ##################################
# This makefile defines four targets that are meant to be used by user #
# from the command line:                                               #
#                                                                      #
# all    - builds all (default if any packages are selected)           #
# help   - shows this help (default if no packages are selected)       #
# clean  - deletes OBJDIR                                              #
# export - exports preparsed Makefile to file EXPORT                   #
############################# EXAMPLES #################################
# Typical usage:                                                       #
#    make PKG=ide FLAGS="GUI MT"                                       #
# More complicated usage:                                              #
#    make PKG="ide UWord Bombs" FLAGS="GUI GCC NOGTK" VERBOSE=y        #
# Building "theide" instead of "ide":                                  #
#    make PKG=ide BINPREFIX=bin/the                                    #
# Export makefile with full dependencies:                              #
#    make export PKG=ide FAST=n                                        #
# Show help:                                                           #
#    make OR make help                                                 #
# Simulation mode:                                                     #
#    make PKG=ide SIMULATE=y                                           #
# Silent mode:                                                         #
#    make PKG=ide SILENT=y                                             #
# Paralel compilation (3 paralel processes):                           #
#    make PKG=ide JOBS=3                                               #
############################# DEFAULTS #################################
# List of packages to build (space separated).                         #
# If empty, this help text will be shown.                              #
PKG=
# Paths where to look for packages.                                    #
NESTS=bazaar examples reference tutorial uppsrc
# Flags as in TheIDE.
# The only difference is, that if you use SPEED or SIZE flag, then     #
# the application will be optimized for Speed or Size, respectively.   #
# Flags STATIC and ALLSHARED will determine the linking mode.          #
FLAGS=GCC
# Additional include paths for compiler (without  leading "-I").       #
INCPATHS:=
# Paths to libraries for linker.                                       #
LIBPATHS:=
# Directory to store intermediate object files                         #
OBJDIR:= _out
# Extension added to resulting executables                             #
BINEXT:=
# Prefix for resulting binaries. Usually used with "/" at the end,     #
# to specify the directory (hence the name)                            #
BINPREFIX:=bin/
# ar command                                                           #
AR:= ar -src
# C compiler command                                                   #
CC:= c++
# C++ compiler command                                                 #
CXX:=$(CC)
# Options for C compiler                                               #
CFLAGS:=
# Options for C++ compiler                                             #
CXXFLAGS:=
# Options for linker                                                   #
LDFLAGS:=-Wl,--gc-sections -Wl,-s -Wl,-O,2
# Additional options for speed optimization                            #
SPEEDFLAGS:=-O3 -ffunction-sections -fdata-sections
# Additional options for size optimization                             #
SIZEFLAGS:=-Os -finline-limit=20 -ffunction-sections -fdata-sections
# Platform flag, added to FLAGS                                        #
PLATFORM:=$(shell uname | tr a-z A-Z) POSIX
# Suppress all messagges                                               #
SILENT:=
# Print each executed command                                          #
VERBOSE:=
# Print each executed command, prepended with "SIMULATE: ", without    #
# actually executing it.                                               #
SIMULATE:=
# Do not make full dependency scan (using gcc -M switch).              #
# This saves a lot of time and usually doesn't make any harm.          #
# FAST mode must by turned on only if you modified include files (*.h, #
# *.lay, ...) without modifying the *.c/cpp files that include them.   # 
FAST:=y
# Add flags from based on mainconfig section (not implemented yet)     #
USEMAINCFG:=
# Number of parallel jobs to use (like "make -jN" option).             #
# The JOBS variable must be used instead of -j option (as -j would not #
# work as expected). Default value is the number of cores (if it is    #
# possible to detect) or 1.                                            #
JOBS:=$(shell echo /sys/devices/system/cpu/cpu[0-9] | wc -w || echo 1)
# External parser to use instead of the contained one. Also used       #
# for manipulation with the internal parser (see update-parser,        #
# and export-parser targets in this Makefile for details).             #
PARSER:=
# Exported makefile (used only with export target)                     #
# If multiple packages are being exported, each produces additional    #
# Makefile, which name is EXPORT.package_name                          #
EXPORT:=Makefile.export
# Awk binary. Used only for export.                                    #
AWK:=awk
########################################################################
# HELP END

ifeq ($(filter 3.8%, $(MAKE_VERSION)), )
$(error This Makefile only supports GNU make version 3.80 and newer)
endif

# no need to parse dependencies just to clean up or to read help etc.
ifeq ($(MAKECMDGOALS),clean)
skip-parse:=y
endif
ifeq ($(MAKECMDGOALS),help)
skip-parse:=y
endif
ifeq ($(MAKECMDGOALS),export)
skip-parse:=y
endif
ifeq ($(PKG),)
skip-parse:=y
endif

# Determine the name of this Makefile
filename:=$(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))

# Helper functions to put variables on cmdline
pass-var= "$1=$$($1)"
export-var= "$1=$($1)"
# list of user variables to pass to child processes
cmdline-vars=NESTS FLAGS INCPATHS LIBPATHS OBJDIR BINEXT BINPREFIX AR CC CXX\
 CFLAGS CXXFLAGS LDFLAGS SPEEDFLAGS SIZEFLAGS PLATFORM\
 SILENT VERBOSE SIMULATE FAST USEMAINCFG
L:=(
R:=)
CONFIRM=y Y yes YES Yes true True T TRUE t 1 on On ON @
confirm=$(filter $(strip $1),$(CONFIRM))
# verbose/silent/fast mode switches
S:=$(call confirm,$(SILENT))
M:=$(if $(call confirm,$(VERBOSE)),,@)
M:=$(if $(call confirm,$(SIMULATE)),@echo SIMULATE: ,$M)
F:=$(call confirm,$(FAST))
# echo a string if silent mode is not on
echo=$(if $S,,@echo $1)

ifneq ($(skip-parse),y)

flags:=$(sort $(FLAGS) $(PLATFORM))
CINC:=$(foreach d,$(NESTS) $(INCPATHS), -I$d) -I/usr/include/freetype2 -I/usr/include/gtk-2.0 -I/usr/local/include/gtk-2.0 -I/usr/include/glib-2.0 -I/usr/local/include/glib-2.0 -I/usr/lib/glib-2.0/include -I/usr/local/lib/glib-2.0/include -I/usr/lib/gtk-2.0/include -I/usr/local/lib/gtk-2.0/include -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/atk-1.0 -I/usr/X11R6/include -I/usr/X11R6/include/freetype2 -I/usr/X11R6/include/gtk-2.0 -I/usr/X11R6/include/glib-2.0 -I/usr/X11R6/lib/glib-2.0/include -I/usr/X11R6/lib/gtk-2.0/include -I/usr/X11R6/include/cairo -I/usr/X11R6/include/pango-1.0 -I/usr/X11R6/include/atk-1.0 -I/usr/local/include/cairo -I/usr/local/include/pango-1.0 -I/usr/local/include/atk-1.0 -I/usr/local/include -I/usr/local/include/libpng -I/usr/include/gdk-pixbuf-2.0 -I/usr/lib/i386-linux-gnu/glib-2.0/include -I/usr/lib/x86_64-linux-gnu/glib-2.0/include -I/usr/lib/i386-linux-gnu/gtk-2.0/include -I/usr/lib/x86_64-linux-gnu/gtk-2.0/include -I/usr/include/gtk-3.0/gdk
LIBPATH:=$(foreach d,$(LIBPATHS), -L$d) -L/usr/X11R6/lib -L/usr/lib -L/usr/local/lib
needed-dirs:=
begin-group:=-Wl,--start-group
end-group:=-Wl,--end-group
# MacOsX specific things
ifeq ($(filter $(PLATFORM),DARWIN),DARWIN)
begin-group:=
end-group:=
endif
# Return true, if package $2 is to be compiled with flag $1
has-flag=$(filter $1,$2)
#Join array with "_"
concatenate=$(strip $(if $1,$(if $(filter $(words $1),1),$1,\
     $(firstword $1)_$(call concatenate,$(wordlist 2,$(words $1),$1)))))
# Return output directory for .o files, based on pkg name and flags
objdir=$(OBJDIR)/$1/$(call concatenate,$($1_FLAGS))
# prepare output directories targets
define create-dir
needed-dirs+= $1
$1:
	$(call echo,"    Creating directory $1 ...")
	$Mmkdir -p $1
endef
needs-dir=$(if $(filter $(needed-dirs),$1),,$(eval $(call create-dir,$1))) $1
# get dependencies recursively
get-deps=$(strip $(foreach p,$($1_USES),$(call get-deps,$p)) $1)

# Compiler commands
compiler-cpp=$(CXX) -c -x c++ $(CXXFLAGS)
compiler-c=$(CC) -c -x c $(CFLAGS)
analyze-info=$(if $S,,    Analyzing $1 dependencies ...)
includes-fetcher-c=$(info $(analyze-info))$(CC) -M -x c $(CXXFLAGS)
includes-fetcher-cpp=$(info $(analyze-info))$(CC) -M -x c++ $(CFLAGS)

# file counting utilities for progress reports
C:=$(OBJDIR)/.make_counter
incrementor:=while ! ln -s -T '$C' '$C_lock' 2>/dev/null;do true; done; echo -n $$$$(($$$$(cat '$C')+1))>'$C';cat '$C'; rm $C_lock;
counter-beg:=c=0; for f in 
counter-end:=; do [ -e $$f ] && c=$$(($$c+1)); done; echo $$c;

# general target scheme (args:{deps,target,pkg,lang,flags}
define compile
$2: $(if $F,$($3_NEST)/$1,$(dir $2)$(shell $(includes-fetcher-$4) $5 $(CINC) $($3_MACRO) $($3_NEST)/$1 |tr -d '\\\\' | sed 's/^[^:]*://')) | $(call needs-dir,$(dir $2))
	$(call echo,"    Compiling $1 $Lflags $(strip $($3_FLAGS))$R ["`$(incrementor)`"/$(file-num)] ...") 
	$M$(compiler-$4) $5 $(CINC) $($3_MACRO) $($3_NEST)/$1 -o $2
$(EMPTYLINE)
endef

#compile .cpp/.c/.icpp into .o/.io
compile-cpp=$(call compile,$1,$2,$3,cpp,)
compile-c=$(call compile,$1,$2,$3,c,)
compile-icpp=$(call compile,$1,$2,$3,cpp,)
# ditto with speed optimization
compile-cpp-speed=$(call compile,$1,$2,$3,cpp,$(SPEEDFLAGS))
compile-c-speed=$(call compile,$1,$2,$3,c,$(SPEEDFLAGS))
compile-icpp-speed=$(call compile,$1,$2,$3,cpp,$(SPEEDFLAGS))
