=== uppbox/lpbuild2/debian/changelog ===
upp (1) any; urgency=low

  * Fake changelog! Only to make uscan work.

 -- Jan Dolinar <dolik.rce@seznam.cz>  Mon, 27 Feb 2012 16:24:38 +0100
